#!/usr/bin/perl -w

my ($KDEOUT, $GNOMEROOT, $GNOMEROOT2, $GNOMEROOT3, $KDEFILE, $KFILE, $BFILE, $BDIR, %gnomed, $ddata);

my @gpath = (shift, $ENV{'GNOMEDIR'}, "/usr");
while(@gpath) { last if defined($GNOMEROOT = shift @gpath); };

$GNOMEROOT .= "/share/gnome/apps";
$KDEOUT = $ENV{'HOME'}."/.kde/share/applnk/GNOME-Apps";

(-d $GNOMEROOT) or &perror("Unable to find GNOME in ", $GNOMEROOT);
mkdir($KDEOUT, 0700) or &perror("Unable to create folder ", $KDEOUT)
	unless (-d $KDEOUT);

chdir($GNOMEROOT);
open PIPE, "find . -type d |" or &perror("Unable to read GNOME menu");
while(<PIPE>) {
	chomp;
	mkdir($KDEOUT."/".$_, 0700) or &perror("Unable to create ", $_)
		unless(-d $KDEOUT."/".$_);
}
close PIPE;
wait;

open PIPE, "find . -type f |" or &perror("Unable to read GNOME menu");
CONVERT: while(<PIPE>) {
	chomp;
	next CONVERT unless /^(.*)\/([^\/]+)$/;
	$BDIR = $1;
	$GFILE = $2;
	$BFILE = $GFILE;
	$BFILE =~ s/\.desktop$//;
	$KFILE = $BFILE.".kdelnk";
	%gded = ();

	open GNOME, "<".$BDIR."/".$GFILE or eval {
		print STDERR "Unable to open ",$BDIR,"/",$GFILE,": ",$!,"\n";
		next CONVERT;
	};
	READ: while(<GNOME>) {
		last READ if /^\[Desktop Entry\]/;
	}
	READ: while(<GNOME>) {
		chomp;
		$gded{$1} = $2 if /^([^=]+)=(.*)$/;
	}
	close GNOME;

	open KDELNK, ">".$KDEOUT."/".$BDIR."/".$KFILE or eval {
		print STDERR "Unable to open ",$BDIR,"/",$KFILE,": ",$!,"\n";
		next CONVERT;
	};
	print KDELNK "# KDE Config File\n";
	print KDELNK "[KDE Desktop Entry]\n";
	$ddata = "Application" unless $ddata = $gded{'Type'};
	print KDELNK "Type=", $ddata, "\n";
	$ddata = $BFILE unless $ddata = $gded{'Name'};
	print KDELNK "Name=", $ddata, "\n";
	if(defined($gded{'Terminal'}) && ($gded{'Terminal'} eq "true")) {
		print KDELNK "Terminal=1\n";
	} else {
		print KDELNK "Terminal=0\n";
	}
	print KDELNK "Exec=", $gded{'Exec'}, "\n" if $gded{'Exec'};
	print KDELNK "Icon=/usr/share/pixmaps/", $gded{'Icon'}, "\n" if $gded{'Icon'};
	close KDELNK;
}
close PIPE;
wait;

# Extra stuff for RedHat Linux 6.0 aka Hedwig and above.

$GNOMEROOT2 = "/etc/X11/applnk";

(-d $GNOMEROOT2) or &perror2("You dont use a Redhat 6.0 System (this is not an
error!) \n /etc/X11/applnk"); mkdir($KDEOUT, 0700) or &perror("Unable to
create folder ", $KDEOUT) 	unless (-d $KDEOUT);

chdir($GNOMEROOT2);
open PIPE, "find . -type d |" or &perror("Unable to read GNOME menu");
while(<PIPE>) {
	chomp;
	mkdir($KDEOUT."/".$_, 0700) or &perror("Unable to create ", $_)
		unless(-d $KDEOUT."/".$_);
}
close PIPE;
wait;

open PIPE, "find . -type f |" or &perror("Unable to readRed GNOME menu");
CONVERT: while(<PIPE>) {
	chomp;
	next CONVERT unless /^(.*)\/([^\/]+)$/;
	$BDIR = $1;
	$GFILE = $2;
	$BFILE = $GFILE;
	$BFILE =~ s/\.desktop$//;
	$KFILE = $BFILE.".kdelnk";
	%gded = ();

	open GNOME, "<".$BDIR."/".$GFILE or eval {
		print STDERR "Unable to open ",$BDIR,"/",$GFILE,": ",$!,"\n";
		next CONVERT;
	};
	READ: while(<GNOME>) {
		last READ if /^\[Desktop Entry\]/;
	}
	READ: while(<GNOME>) {
		chomp;
		$gded{$1} = $2 if /^([^=]+)=(.*)$/;
	}
	close GNOME;

	open KDELNK, ">".$KDEOUT."/".$BDIR."/".$KFILE or eval {
		print STDERR "Unable to open ",$BDIR,"/",$KFILE,": ",$!,"\n";
		next CONVERT;
	};
	print KDELNK "# KDE Config File\n";
	print KDELNK "[KDE Desktop Entry]\n";
	$ddata = "Application" unless $ddata = $gded{'Type'};
	print KDELNK "Type=", $ddata, "\n";
	$ddata = $BFILE unless $ddata = $gded{'Name'};
	print KDELNK "Name=", $ddata, "\n";
	if(defined($gded{'Terminal'}) && ($gded{'Terminal'} eq "true")) {
		print KDELNK "Terminal=1\n";
	} else {
		print KDELNK "Terminal=0\n";
	}
	print KDELNK "Exec=", $gded{'Exec'}, "\n" if $gded{'Exec'};
	print KDELNK "Icon=/usr/share/pixmaps/", $gded{'Icon'}, "\n" if $gded{'Icon'};
	close KDELNK;
}
close PIPE;
wait;
exit;

sub perror2 {
	print STDERR @_, ": ", $!, "\n";
}


sub perror {
	print STDERR @_, ": ", $!, "\n";
	exit;
}
